<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EditaResumoRetencaoXML StructType
 * @subpackage Structs
 */
class EditaResumoRetencaoXML extends AbstractStructBase
{
    /**
     * The idHistorico
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $idHistorico;
    /**
     * The forceRefresh
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $forceRefresh;
    /**
     * Constructor method for EditaResumoRetencaoXML
     * @uses EditaResumoRetencaoXML::setIdHistorico()
     * @uses EditaResumoRetencaoXML::setForceRefresh()
     * @param string $idHistorico
     * @param bool $forceRefresh
     */
    public function __construct($idHistorico = null, $forceRefresh = null)
    {
        $this
            ->setIdHistorico($idHistorico)
            ->setForceRefresh($forceRefresh);
    }
    /**
     * Get idHistorico value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getIdHistorico()
    {
        return isset($this->idHistorico) ? $this->idHistorico : null;
    }
    /**
     * Set idHistorico value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $idHistorico
     * @return \StructType\EditaResumoRetencaoXML
     */
    public function setIdHistorico($idHistorico = null)
    {
        // validation for constraint: string
        if (!is_null($idHistorico) && !is_string($idHistorico)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idHistorico)), __LINE__);
        }
        if (is_null($idHistorico) || (is_array($idHistorico) && empty($idHistorico))) {
            unset($this->idHistorico);
        } else {
            $this->idHistorico = $idHistorico;
        }
        return $this;
    }
    /**
     * Get forceRefresh value
     * @return bool|null
     */
    public function getForceRefresh()
    {
        return $this->forceRefresh;
    }
    /**
     * Set forceRefresh value
     * @param bool $forceRefresh
     * @return \StructType\EditaResumoRetencaoXML
     */
    public function setForceRefresh($forceRefresh = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceRefresh) && !is_bool($forceRefresh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($forceRefresh)), __LINE__);
        }
        $this->forceRefresh = $forceRefresh;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EditaResumoRetencaoXML
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
